; MIDI Routine voor Music-Module en FMI
; intypen in teksteditor (bv TED) en wegschrijven onder de naam
; MIDIBIOS.INC
; Te gebruiken als include file voor Gen80: *I MIDIBIOS.INC
;
; MSX Computer Magazine

midi_int                 ; Initialiseer de MIDI-interface
                         ; en kijk welke interface aanwezig is
                         ; Deze routine altijd als eerste
aanroepen
     ld   b,1            ; b=ID FAC MIDI Interface (FMI)
     in   a,(2)          ; Status FMI in a
     cp   255            ; FMI aanwezig?
     jr   nz,init2       ; Zoja, ga naar init2
     inc  b              ; Verhoog ID (2=Music Module)
     in   a,(#c0)        ; Status Music Module in a
     cp   255            ; Music Module aanwezig?
     jr   nz,init2       ; Zoja, ga naar init2
     ld   b,0            ; b=ID geen interface aanwezig (0)
init2
     ld   a,b            ; a=b=ID code
     ld   (interface),a  ; Schrijf op adres interface
     call initmidi       ; Initialiseer de aangesloten interface
     ret                 ; en keer terug

midi_out                 ; stuur data naar MIDI-OUT poort
                         ; in: a=data
     push af             ; bewaar af
     push bc             ; bewaar bc
     ld   b,a            ; b=a=data
     ld   a,(interface)  ; interface ID in a
     cp   1              ; Is het de FMI?
     jr   z,fmi_out      ; ga dan naar FMI_OUT
mod_out
     in   a,(4)          ; MIDI-status Music Module in a
     and  2              ; Kijk alleen naar bit 1
     jr   z,mod_out      ; Wacht tot zendbuffer leeg is
     ld   a,b            ; a=b=data
     out  (1),a          ; Stuur naar MIDI-OUT poort
     jr   end_out        ; en spring naar einde routine

fmi_out   
     in   a,(3)          ; MIDI-status FMI in a
     and  1              ; kijk alleen naar bit 0
     jr   z,fmi_out      ; Wacht tot zendbuffer leeg is
     ld   a,b            ; a=b=data
     out  (2),a          ; Stuur naar MIDI-OUT poort
end_out
     pop   bc            ; Herstel bc
     pop  af             ; Herstel af
     ret                 ; en keer terug

initmidi                 ; Initialiseert MIDI-interface
     push af             ; Bewaar af
     ld   a,(interface)  ; a=interface ID
     and  a              ; Update flag register
     jr   z,stopinit     ; Stop met init als geen interface
aanwezig
     cp   1              ; Is het de FMI
     jr   z,fmi_init     ; Zoja, ga naar FMI_init
mod_init                 ; Init Music Module MIDI
     ld   a,3            ; reset instellingen
     out  (0),a
     ld   a,21           ; Zet snelheid op 31250 bps
     out  (0),a
stopinit  pop  af        ; Herstel af
     ret                 ; keer terug
fmi_init
     xor  a              ; a=0
     out  (3),a          ; Zet snelheid op 31250 bps
     out  (3),a
     out  (3),a
     ld   a,#40
     out  (3),a
     ld   a,#4e
     out  (3),a
     ld   a,#15
     out  (3),a
     pop  af
     ret

interface                ; 0=geen interface aanwezig
                         ; 1=FAC MIDI interface
                         ; 2=Music Module
     defb 0

chan_off                 ; Zet MIDI-kanaal uit 
                         ; in a=MIDI-kanaal (1..16)
     push af             ; Bewaar af
     and  15             ; alleen laagste 4 bits
     dec  a              ; a=a-1
     or   #b0            ; Controller status-byte
     call midi_out       ; Schrijf naar MIDI-poort
     ld   a,#7b          ; All notes off controller
     call midi_out
     xor  a              ; a=0
     call midi_out
     pop  af             ; Herstel af
     ret                 ; keer terug

progchange               ; In: c=instrument (1..128)
                         ; B=MIDI-kanaal (1..16)
     push af             ; Bewaar af
     ld   a,b            ; a=MIDI-kanaal
     and  15             ; alleen laagste 4 bits
     dec  a              ; a=a-1
     or   #c0            ; Program change status byte
     call midi_out       ; Schrijf naar MIDI-poort
     ld   a,c            ; a=c=intrument
     dec  a              ; verlaag met 1
     call midi_out       ; Stuur naar MIDI-OUT
     pop  af             ; Herstel af
     ret                 ; en keer weer terug

; Einde include file
